/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSRect;

import dwt.internal.cocoa.CGFloat;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSPoint;
import dwt.internal.cocoa.NSSize;

extern (C):

alias NSRect* NSRectArray;
alias NSRect* NSRectPointer;

enum NSRectEdge : NSUInteger
{
    NSMinXEdge = 0,
    NSMinYEdge = 1,
    NSMaxXEdge = 2,
    NSMaxYEdge = 3
}

alias NSRectEdge.NSMinXEdge NSMinXEdge;
alias NSRectEdge.NSMinYEdge NSMinYEdge;
alias NSRectEdge.NSMaxXEdge NSMaxXEdge;
alias NSRectEdge.NSMaxYEdge NSMaxYEdge;

struct NSRect
{
    NSPoint origin;
    NSSize size;
    
    // for dwt compatibility
    
    CGFloat x ()
    {
        return origin.x;
    }
    
    CGFloat x (CGFloat x)
    {
        return origin.x = x;
    }
    
    CGFloat y ()
    {
        return origin.y;
    }
    
    CGFloat y (CGFloat y)
    {
        return origin.y = y;
    }
    
    CGFloat width ()
    {
        return size.width;
    }
    
    CGFloat width (CGFloat width)
    {
        return size.width = width;
    }
    
    CGFloat height ()
    {
        return size.height;
    }
    
    CGFloat height (CGFloat height)
    {
        return size.height = height;
    }
    
    /*alias origin.x x;
    alias origin.y y;
    alias size.width width;
    alias size.height height;*/
}